function getParameterByName(name)
{
  name = name.replace(/[\[]/, "\\\[").replace(/[\]]/, "\\\]");
  var regexS = "[\\?&]" + name + "=([^&#]*)";
  var regex = new RegExp(regexS);
  var results = regex.exec(window.location.search);
  if(results == null)
    return "";
  else
    return decodeURIComponent(results[1].replace(/\+/g, " "));
}

var conditions={};
var actions={};
function loadValues(id){
    var sResult = ajaxSyncRequest('/json/property/query', {
        'query' : '/scripts/system-addon-timed-events/entries/'+id+'(*)/*(*)/*(*)'
    });
    var resultObj = JSON.parse(sResult);
    if (resultObj.ok) {
        var subObj = resultObj.result[id][0];
        var oObject = {};
        document.getElementById('name').value=subObj.name;
        document.getElementById('id').value= subObj.id;
        oconditions = {};
        var oSubObj = null;
        for (var sKey in subObj) {
            if (typeof(subObj[sKey])=='object')
                oSubObj=subObj[sKey];
        }
        for ( var jIndex = 0; jIndex < oSubObj.length; jIndex++) {
            if (oSubObj[jIndex].actions != null) {
                actions = oSubObj[jIndex].actions;
                renderActions();
            }
            if (oSubObj[jIndex].timeBase != null)
                document.getElementById('timeBase').value = oSubObj[jIndex].timeBase;
            if (oSubObj[jIndex].limitBefore != null)
            {
                document.getElementById('limitBeforeH').value = Math.floor(oSubObj[jIndex].limitBefore/3600);
                document.getElementById('limitBeforeM').value = Math.floor(oSubObj[jIndex].limitBefore/60)%60;
                document.getElementById('limitBeforeS').value = oSubObj[jIndex].limitBefore%60;
            }
            if (oSubObj[jIndex].limitAfter != null){
                document.getElementById('limitAfterH').value = Math.floor(oSubObj[jIndex].limitAfter/3600);
                document.getElementById('limitAfterM').value = Math.floor(oSubObj[jIndex].limitAfter/60)%60;
                document.getElementById('limitAfterS').value = oSubObj[jIndex].limitAfter%60;
            }
            if (oSubObj[jIndex].offset != null) {
                document.getElementById('offsetH').value = Math.floor(oSubObj[jIndex].offset/3600);
                document.getElementById('offsetM').value = Math.floor(oSubObj[jIndex].offset/60)%60;
                document.getElementById('offsetS').value = oSubObj[jIndex].offset%60;
            }
            if (oSubObj[jIndex].propertyReference != null) {
                document.getElementById('timeBase').value='propertyReference';
                document.getElementById('reference').value=oSubObj[jIndex].propertyReference;
            }            
            if (oSubObj[jIndex].recurrenceBase != null)
                document.getElementById('recurrenceBase').value = oSubObj[jIndex].recurrenceBase;
            
            if (oSubObj[jIndex].time != null) {                    
                if (oSubObj[jIndex].recurrenceBase == 'weekly') {
                    document.getElementById('recurrence').value = '';
                    for ( var kIndex = 0; kIndex < oSubObj[jIndex].time.length; kIndex++) {
                        if (oSubObj[jIndex].time[kIndex]) {
                            for ( var sKey in oSubObj[jIndex].time[kIndex]) {
                                document.getElementById('recurrence').value += oSubObj[jIndex].time[kIndex][sKey] + ',';
                            }
                        }
                    }
                } else {
                    document.getElementById('recurrence').value = '';
                    for ( var kIndex = 0; kIndex < oSubObj[jIndex].time.length; kIndex++) {
                        if (oSubObj[jIndex].time[kIndex]) {
                            for ( var sKey in oSubObj[jIndex].time[kIndex]) {
                                document.getElementById('recurrence').value += oSubObj[jIndex].time[kIndex][sKey] + ',';
                            }
                        }
                    }
                }
                if (oSubObj[jIndex].random!=null)
                    document.getElementById('random').value=oSubObj[jIndex].random;
            }
/*            if (oSubObj[jIndex].enabled) {
                oObject.conditions.enabled = oSubObj[jIndex].enabled;
            }
            if (oSubObj[jIndex].conditions) {
                for ( var kIndex = 0; kIndex < oSubObj[jIndex].conditions.length; kIndex++) {
                    for ( var sKey in oSubObj[jIndex].conditions[kIndex])
                        oObject.conditions[sKey] = oSubObj[jIndex].conditions[kIndex][sKey];
                }
            }*/
        }        
    }

}

function init()
{
    var id=getParameterByName('id');
    if (id=="")
        return;
    initValues();
    loadValues(id);
}

function deleteAction(index) {
    actions.splice(parseInt(index,10),1);
    renderActions();
}

function renderActions() {
    document.getElementById('actionContainer').innerHTML="";
    for (var kIndex=0;kIndex<actions.length;kIndex++){
        addAction(kIndex);
    }
    for (var kIndex=0;kIndex<actions.length;kIndex++){
        setAction(kIndex,actions[kIndex]);
    }
}

function setAction(index,oObject){
    document.getElementById(index+'actionType').value="-1";    
    document.getElementById(index+'actionZone').value="-1";
    document.getElementById(index+'actionGroup').value="-1";
    document.getElementById(index+'actionScene').value="-1";
    document.getElementById(index+'actionForce').checked=false;
    document.getElementById(index+'actionDevice').value="-1";
    document.getElementById(index+'actionValue').value="";
    document.getElementById(index+'actionHLE').value="-1";
    document.getElementById(index+'actionURL').value="";
    document.getElementById(index+'actionDelay').value="0";
    if (oObject.type!=null)
        document.getElementById(index+'actionType').value=oObject.type;
    enableActions(''+index);
    if (oObject.dsid!=null)
        document.getElementById(index+'actionDevice').value=oObject.dsid;
    if (oObject.zone!=null)
        document.getElementById(index+'actionZone').value=oObject.zone;
    if (oObject.group!=null)
        document.getElementById(index+'actionGroup').value=oObject.group;
    if (oObject.scene!=null)
        document.getElementById(index+'actionScene').value=oObject.scene;
    if (oObject.url!=null)
        document.getElementById(index+'actionURL').value=oObject.url;
    if (oObject.delay!=null)
        document.getElementById(index+'actionDelay').value=oObject.delay;
    if (oObject.event!=null)
        document.getElementById(index+'actionHLE').value=oObject.event;
    if (oObject.value!=null)
        document.getElementById(index+'actionValue').value=oObject.value;
    if (oObject.force!=null)
        document.getElementById(index+'actionForce').checked=oObject.force;
}
function updateValue(index) {
    var sType=document.getElementById(index+'actionType').value;
    var oObject={type:sType};
    switch(oObject.type) {
        case '-1':
            array[index]={};
            break;
        case 'zone-scene':
            oObject.zone=document.getElementById(index+'actionZone').value;
            oObject.groupe=document.getElementById(index+'actionGroup').value;
            oObject.scene=document.getElementById(index+'actionScene').value;
            oObject.force=document.getElementById(index+'actionForce').checked;
            oObject.delay=document.getElementById(index+'actionDelay').value;
            break;
        case 'device-scene':
            oObject.scene=document.getElementById(index+'actionScene').value;
            oObject.force=document.getElementById(index+'actionForce').checked;
            oObject.dsid=document.getElementById(index+'actionDevice').value;
            break;
        case 'device-value':
            oObject.dsid=document.getElementById(index+'actionDevice').value;
            oObject.value=document.getElementById(index+'actionValue').value;
            break;
        case 'device-blink':
            oObject.dsid=document.getElementById(index+'actionDevice').value;
            break;
        case 'zone-blink':
            oObject.zone=document.getElementById(index+'actionZone').value;
            oObject.group=document.getElementById(index+'actionGroup').value;
            break;
        case 'custom-event':           
            oObject.event=document.getElementById(index+'actionHLE').value;
            break;
        case 'url':
            oObject.url=document.getElementById(index+'actionURL').value;
            break;
    }
    actions[index]=oObject;
}
function addAction(index) {
    var sString='<tr><td>Typ</td><td><select id="'+index+'actionType" onchange="enableActions(\''+index+'\');updateValue('+index+');">';
    sString+='<option "selected"=selected value="-1">-----</option><option value="zone-scene">Szenenaufruf im Raum</option><option value="zone-blink">Blinken im Raum</option><option value="device-scene">Szenenaufruf im Ger&auml;t</option><option value="device-blink">Blinken im Ger&auml;t</option><option value="device-value">Wert setzen im Ger&auml;t (Achtung b&ouml;se!)</option><option value="custom-event">HLE</option><option value="url">URL</option>';
    sString+='</select><td>Delay</td><td><input type="text" id="'+index+'actionDelay" onchange="updateValue('+index+');"></td></tr><tr><td>Raum</td>';
    sString+='<td><select id="'+index+'actionZone" onchange="updateValue('+index+');"><option "selected"=selected value="-1">----</option>';
    for (var iIndex=0;iIndex<nameCache.length;iIndex++) {
        sString+='<option value='+nameCache[iIndex].ZoneID+'>'+nameCache[iIndex].name+' ('+nameCache[iIndex].ZoneID+')</option>';
    }
    sString+='</select></td><td>Gruppe</td><td><select id="'+index+'actionGroup" onchange="updateValue('+index+');"><option "selected"=selected value="-1">-----</option>';
    sString+='<option value="0">Broadcast (0)</option>';
    sString+='<option value="1">Licht (1)</option>';
    sString+='<option value="2">Schatten (2)</option>';
    sString+='<option value="3">Klima (3)</option>';
    sString+='<option value="4">Audio (4)</option>';
    sString+='<option value="5">Video (5)</option>';
    sString+='<option value="6">Sicherheit (6)</option>';
    sString+='<option value="7">Zugang (7)</option>';
    for (var iIndex=8;iIndex<64;iIndex++)
        sString+='<option value="'+iIndex+'">Gruppe '+iIndex+' ('+iIndex+')</option>';
    sString+='</select></td></tr><tr><td>Scene</td><td><select id="'+index+'actionScene" onchange="updateValue('+index+');"><option "selected"=selected value="-1">-----</option>';
    for (var iIndex=0;iIndex<128;iIndex++)
        sString+='<option value="'+iIndex+'">'+getNameForScene(0,0,iIndex)+' ('+iIndex+')</option>';
    sString+='</select></td><td>Force</td><td><input type="checkbox" id="'+index+'actionForce" onchange="updateValue('+index+');"></td></tr><tr><td>Ger&auml;t</td><td><select id="'+index+'actionDevice"><option "selected"=selected value="-1">-----</option>';
    
    deviceCache.sort(function(a,b){return a.ZoneID<b.ZoneID;})
    for (var iIndex=0;iIndex<deviceCache.length;iIndex++) {
        if (deviceCache[iIndex].present)
            sString+='<option value="'+deviceCache[iIndex].dSID+'">' + getNameForZone(deviceCache[iIndex].ZoneID) + ' - ' + deviceCache[iIndex].name + ' ('+deviceCache[iIndex].dSID.substring(16)+')</option>';
    }
    sString+='</select></td><td>Wert</td><td><input type="text" id="'+index+'actionValue" onchange="updateValue('+index+');"></td></tr><tr><td>HLE-Name</td><td><select id="'+index+'actionHLE" onchange="updateValue('+index+');"><option "selected"=selected value="-1">-----</option>';
    for (var iIndex=0;iIndex<HLECache.length;iIndex++) {
        sString+='<option value="'+HLECache[iIndex].id+'">' +HLECache[iIndex].name +' ('+HLECache[iIndex].id+')</option>';
    }
    sString+='</select></td><td>URL</td><td><input type="text" id="'+index+'actionURL" onchange="updateValue('+index+');"></td></tr>';
    if (actions.length>1)
        sString+='<tr><td colspan="4" align="right"><a class="kleinbutton" onclick="deleteAction('+index+')">L&ouml;schen</a></td></tr>';
    sString+='<tr><td colspan="4"><hr></td></tr>';
    document.getElementById('actionContainer').innerHTML+=sString;
    enableActions(''+index);
}

function enableActions(selectorID) {
    var value=document.getElementById(selectorID+'actionType').value;
    switch(value) {
        case '-1':
            document.getElementById(selectorID+'actionZone').disabled=true;
            document.getElementById(selectorID+'actionGroup').disabled=true;
            document.getElementById(selectorID+'actionScene').disabled=true;
            document.getElementById(selectorID+'actionForce').disabled=true;
            document.getElementById(selectorID+'actionDevice').disabled=true;
            document.getElementById(selectorID+'actionValue').disabled=true;
            document.getElementById(selectorID+'actionHLE').disabled=true;
            document.getElementById(selectorID+'actionURL').disabled=true;
            break;
        case 'zone-scene':
            document.getElementById(selectorID+'actionZone').disabled=false;
            document.getElementById(selectorID+'actionGroup').disabled=false;
            document.getElementById(selectorID+'actionScene').disabled=false;
            document.getElementById(selectorID+'actionForce').disabled=false;
            document.getElementById(selectorID+'actionDevice').disabled=true;
            document.getElementById(selectorID+'actionValue').disabled=true;
            document.getElementById(selectorID+'actionHLE').disabled=true;
            document.getElementById(selectorID+'actionURL').disabled=true;
            break;
        case 'device-scene':
            document.getElementById(selectorID+'actionZone').disabled=true;
            document.getElementById(selectorID+'actionGroup').disabled=true;
            document.getElementById(selectorID+'actionScene').disabled=false;
            document.getElementById(selectorID+'actionForce').disabled=false;
            document.getElementById(selectorID+'actionDevice').disabled=false;
            document.getElementById(selectorID+'actionValue').disabled=true;
            document.getElementById(selectorID+'actionHLE').disabled=true;
            document.getElementById(selectorID+'actionURL').disabled=true;
            break;
        case 'device-value':
            document.getElementById(selectorID+'actionZone').disabled=true;
            document.getElementById(selectorID+'actionGroup').disabled=true;
            document.getElementById(selectorID+'actionScene').disabled=true;
            document.getElementById(selectorID+'actionForce').disabled=true;
            document.getElementById(selectorID+'actionDevice').disabled=false;
            document.getElementById(selectorID+'actionValue').disabled=false;
            document.getElementById(selectorID+'actionHLE').disabled=true;
            document.getElementById(selectorID+'actionURL').disabled=true;
            break;
        case 'device-blink':
            document.getElementById(selectorID+'actionZone').disabled=true;
            document.getElementById(selectorID+'actionGroup').disabled=true;
            document.getElementById(selectorID+'actionScene').disabled=true;
            document.getElementById(selectorID+'actionForce').disabled=true;
            document.getElementById(selectorID+'actionDevice').disabled=false;
            document.getElementById(selectorID+'actionValue').disabled=true;
            document.getElementById(selectorID+'actionHLE').disabled=true;
            document.getElementById(selectorID+'actionURL').disabled=true;
            break;
        case 'zone-blink':
            document.getElementById(selectorID+'actionZone').disabled=false;
            document.getElementById(selectorID+'actionGroup').disabled=false;
            document.getElementById(selectorID+'actionScene').disabled=true;
            document.getElementById(selectorID+'actionForce').disabled=true;
            document.getElementById(selectorID+'actionDevice').disabled=true;
            document.getElementById(selectorID+'actionValue').disabled=true;
            document.getElementById(selectorID+'actionHLE').disabled=true;
            document.getElementById(selectorID+'actionURL').disabled=true;
            break;
        case 'custom-event':           
            document.getElementById(selectorID+'actionZone').disabled=true;
            document.getElementById(selectorID+'actionGroup').disabled=true;
            document.getElementById(selectorID+'actionScene').disabled=true;
            document.getElementById(selectorID+'actionForce').disabled=true;
            document.getElementById(selectorID+'actionDevice').disabled=true;
            document.getElementById(selectorID+'actionValue').disabled=true;
            document.getElementById(selectorID+'actionHLE').disabled=false;
            document.getElementById(selectorID+'actionURL').disabled=true;
            break;
        case 'url':
            document.getElementById(selectorID+'actionZone').disabled=true;
            document.getElementById(selectorID+'actionGroup').disabled=true;
            document.getElementById(selectorID+'actionScene').disabled=true;
            document.getElementById(selectorID+'actionForce').disabled=true;
            document.getElementById(selectorID+'actionDevice').disabled=true;
            document.getElementById(selectorID+'actionValue').disabled=true;
            document.getElementById(selectorID+'actionHLE').disabled=true;
            document.getElementById(selectorID+'actionURL').disabled=false;
            break;
    }
}

function save() {
    
}